{
  "cells": [
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "# 15wk-2: 기말고사\n",
        "\n",
        "최규빈  \n",
        "2023-06-19\n",
        "\n",
        "<a href=\"https://colab.research.google.com/github/guebin/PP2023/blob/main/posts/2023-06-19-15wk-2-fin.ipynb\"><img src=\"https://colab.research.google.com/assets/colab-badge.svg\" style=\"text-align: left\"></a>\n",
        "\n",
        "**제출은 `*.ipynb`, `*.html`, `*.pdf` 파일로 제출할 것**\n",
        "\n",
        "-   `ipynb` 파일형태제출을 권장함.\n",
        "\n",
        "# imports"
      ],
      "id": "ed5a3ae4-fae3-40a3-8e19-56ab6504f717"
    },
    {
      "cell_type": "code",
      "execution_count": 5,
      "metadata": {},
      "outputs": [],
      "source": [
        "import numpy as np\n",
        "import matplotlib.pyplot as plt\n",
        "import datetime"
      ],
      "id": "21a5e3fe-6648-481d-8bfe-554d59f978e6"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "# `1`. 묵찌빠 (150점)\n",
        "\n",
        "> **묵찌빠**\n",
        ">\n",
        "> ref: <https://namu.wiki/w/묵찌빠>\n",
        ">\n",
        "> 묵찌빠는 가위바위보의 변형 놀이이다. 보통 가위바위보의 게임과 연이어\n",
        "> 진행되는데, 가위바위보 승부 이후 이긴 사람이 공격권을 가지고,\n",
        "> 묵(바위)/찌(가위)/빠(보자기) 가운데 하나를 외치는 동시에 말한 것과\n",
        "> 일치하도록 손 모양을 바꾼다. 공격권을 가진 사람의 손 모양이\n",
        "> 상대(수비권을 가진 사람)의 손 모양과 일치하면 공격권을 가진 사람의\n",
        "> 승리한다. 승부가 갈리지 않았을 경우에는 다시 가위바위보를 하는 것이\n",
        "> 아니라, 현 상태에서 가위바위보 규칙 상 이긴 사람이 공격권을 가져가게\n",
        "> 된다.\n",
        "\n",
        "`(1)` 아래는 RPS_BASE 클래스의 구현예시이다."
      ],
      "id": "b6cfa3d6-626d-457b-b5d5-55c35262eb93"
    },
    {
      "cell_type": "code",
      "execution_count": 657,
      "metadata": {},
      "outputs": [],
      "source": [
        "class RPS_BASE:\n",
        "    def __init__(self,candidate):\n",
        "        self.candidate = candidate\n",
        "        self.actions = list() \n",
        "    def __setitem__(self,index,val):\n",
        "        self.actions[index] = val\n",
        "    def __getitem__(self,item):\n",
        "        return self.actions[item]        \n",
        "    def __len__(self):\n",
        "        return len(self.actions)\n",
        "    def __eq__(self,other):\n",
        "        return self[-1] == other[-1]\n",
        "    def __gt__(self,other):\n",
        "        return [self[-1],other[-1]] in [['묵','찌'],['찌','빠'],['빠','묵']]\n",
        "    def __ge__(self,other):\n",
        "        return (self == other) or (self > other)\n",
        "    def __lt__(self,other):\n",
        "        return not (self >= other)\n",
        "    def __le__(self,other):\n",
        "        return (self == other) or (self < other)    \n",
        "    def _repr_html_(self):\n",
        "        html_str = \"\"\"\n",
        "        낼 수 있는 패: {} <br/>\n",
        "        기록: {}\n",
        "        \"\"\"        \n",
        "        return html_str.format(self.candidate,self.actions)       \n",
        "    def pick(self):\n",
        "        self.actions.append(np.random.choice(self.candidate))        "
      ],
      "id": "19c7784a-2278-4b08-99b5-b4c1b2c73c0f"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "이 클래스에서 아래와 같은 2명의 플레이어 인스턴스를 생성하라.\n",
        "\n",
        "-   `a`: \\[‘묵’,‘찌’\\] 중에 하나를 랜덤으로 선택\n",
        "-   `b`: \\[‘찌’,‘빠’\\] 중에 하나를 랜덤으로 선택\n",
        "\n",
        "두 인스턴스를 100회 랜덤대결하고 결과를 기록하라. 어떠한 플레이어가 더\n",
        "유리한가?\n",
        "\n",
        "> 답안은 100회중 a몇회 승리, b몇회 승리와 같은 숫자형식으로만 나오면\n",
        "> 인정한다. (코드를 정리하거나 별도의 클래스를 만드는 것을 요구하지\n",
        "> 않음)\n",
        "\n",
        "------------------------------------------------------------------------\n",
        "\n",
        "`(2)` RPS_BASE에서 아래와 같은 두명의 플레이어 인스턴스를 생성하라.\n",
        "\n",
        "-   `a`: \\[‘묵’,‘찌’,‘빠’\\] 중 하나를 랜덤으로 선택\n",
        "-   `b`: \\[‘찌’,‘빠’\\] 중 하나를 랜덤으로 선택\n",
        "\n",
        "아래와 같은 a,b의 attribute을 변경하라."
      ],
      "id": "cff3936c-d60e-4e65-9dc4-fe5b64ba593c"
    },
    {
      "cell_type": "code",
      "execution_count": 672,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.modes = [None]\n",
        "a.actions = [None] \n",
        "b.modes = [None]\n",
        "b.actions = [None]"
      ],
      "id": "13b5e638-5c0b-4d39-bce4-d1efe500df03"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "플레이어 a,b를 이용하여 반복적으로 가위바위보 대결을 수행하고 아래와\n",
        "같이 대결결과에 따라 공격권을 결정하는 함수 `mul`을 만들어라.\n",
        "\n",
        "**경우1: 플레이어 a가 승리할 경우**\n",
        "\n",
        "-   a가 공격모드, b가 수비모드가 된다.\n",
        "-   `a.modes`에는 ‘Attack’ 이 `b.modes`에는 `Defence`가 추가된다.\n",
        "-   `a.actions`와 `b.actions`는 각각의 플레이어가 선택한 패(묵,찌,빠)가\n",
        "    기록된다.\n",
        "\n",
        "**경우2: 플레이어 b가 승리할 경우**\n",
        "\n",
        "-   b가 공격모드, a가 수비모드가 된다.\n",
        "-   `b.modes`에는 ‘Attack’ 이 `a.modes`에는 `Defence`가 추가된다.\n",
        "-   `a.actions`와 `b.actions`는 각각의 플레이어가 선택한 패(묵,찌,빠)가\n",
        "    기록된다.\n",
        "\n",
        "**경우3: 비길경우**\n",
        "\n",
        "-   공격권의 변화는 없다.\n",
        "-   `a.modes`,`b.modes`는 각각 이전의 값이 추가된다.\n",
        "-   `a.actions`와 `b.actions`는 각각의 플레이어가 선택한 패(묵,찌,빠)가\n",
        "    기록된다.\n",
        "\n",
        "아래는 함수 mul을 사용한 예시이다.\n",
        "\n",
        "**시점1: 둘다 찌를 내어 공격권을 아무도 획득하지못함**"
      ],
      "id": "b0c63bc0-e09d-4a8f-b429-4e5e0d601308"
    },
    {
      "cell_type": "code",
      "execution_count": 693,
      "metadata": {},
      "outputs": [],
      "source": [
        "mul(a,b)"
      ],
      "id": "c6b8c6a8-5447-405f-81c7-15bea3a79c76"
    },
    {
      "cell_type": "code",
      "execution_count": 702,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "813fce95-0054-4cb3-bb6d-6788dce352e0"
    },
    {
      "cell_type": "code",
      "execution_count": 703,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "948237f0-44f5-4ad5-a099-dbaa623a38f7"
    },
    {
      "cell_type": "code",
      "execution_count": 704,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.modes"
      ],
      "id": "b2a45c21-dfd5-45e6-b14f-7c66d6b62b76"
    },
    {
      "cell_type": "code",
      "execution_count": 705,
      "metadata": {},
      "outputs": [],
      "source": [
        "b.modes"
      ],
      "id": "f5d82d9a-c9ba-4d7f-90b7-c507b054f9e0"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "**시점2:** 이번에도 둘다 찌를 내어 아무도 공격권을 획득하지 못함"
      ],
      "id": "e9cf531e-e3ea-4a25-98c2-4af8fcf7f36d"
    },
    {
      "cell_type": "code",
      "execution_count": 706,
      "metadata": {},
      "outputs": [],
      "source": [
        "mul(a,b)"
      ],
      "id": "e143c1d8-1f73-42d9-ad37-10013b6d8dd0"
    },
    {
      "cell_type": "code",
      "execution_count": 707,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "641e1aa1-7893-48df-88b4-15cf33f43b8d"
    },
    {
      "cell_type": "code",
      "execution_count": 708,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "4a57f2c9-3dfd-41ba-9d5e-746e910ff1d5"
    },
    {
      "cell_type": "code",
      "execution_count": 709,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.modes"
      ],
      "id": "98e5c03f-39ed-4377-8cbf-cfc6881f8d6f"
    },
    {
      "cell_type": "code",
      "execution_count": 710,
      "metadata": {},
      "outputs": [],
      "source": [
        "b.modes"
      ],
      "id": "8d42dad4-8121-41ad-8249-b9687fa84d76"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "**시점3:** 이번에는 a가 공격권을 획득 (묵\\>찌)"
      ],
      "id": "77a5c618-5ea7-43b2-88f4-1b17ebf8f2e1"
    },
    {
      "cell_type": "code",
      "execution_count": 711,
      "metadata": {},
      "outputs": [],
      "source": [
        "mul(a,b)"
      ],
      "id": "37981f02-123d-4902-90c1-123fc40a6f46"
    },
    {
      "cell_type": "code",
      "execution_count": 712,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "74ded083-6c72-4069-be80-3a3ea982a7bc"
    },
    {
      "cell_type": "code",
      "execution_count": 713,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "629fa94f-03c9-4c9e-91de-1d8a95dcece8"
    },
    {
      "cell_type": "code",
      "execution_count": 714,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.modes"
      ],
      "id": "10c1a068-fe54-45d8-84aa-3309e8bb0a80"
    },
    {
      "cell_type": "code",
      "execution_count": 715,
      "metadata": {},
      "outputs": [],
      "source": [
        "b.modes"
      ],
      "id": "72e42d98-b8a9-43a1-9722-14b496d9e303"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "**시점4:** 이번에는 b가 공격권을 획득 (찌\\>빠)"
      ],
      "id": "4eb71968-6f02-440e-a5fa-86d929209fdd"
    },
    {
      "cell_type": "code",
      "execution_count": 716,
      "metadata": {},
      "outputs": [],
      "source": [
        "mul(a,b)"
      ],
      "id": "787eb3fa-3c4d-4c7b-b836-a4eb5de422e2"
    },
    {
      "cell_type": "code",
      "execution_count": 717,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "c061b7c0-ed91-47c9-8f27-49e68bd7e5d9"
    },
    {
      "cell_type": "code",
      "execution_count": 718,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "74cfc258-af52-4b76-9b93-254622cdf7fd"
    },
    {
      "cell_type": "code",
      "execution_count": 719,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.modes"
      ],
      "id": "cfd3ecf1-4e32-4569-b13d-47803155b859"
    },
    {
      "cell_type": "code",
      "execution_count": 720,
      "metadata": {},
      "outputs": [],
      "source": [
        "b.modes"
      ],
      "id": "2ed06118-1734-4425-a896-c5ae11736f83"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "------------------------------------------------------------------------\n",
        "\n",
        "`(3)` RPS_BASE를 상속받아 MookjjibbaPlayer라는 새로운 클래스를 정의하라.\n",
        "MookjjibbaPlayer 클래스에서 아래의 메소드를 새롭게 정의 혹은 재정의하여\n",
        "\n",
        "1.  `__init__`\n",
        "2.  `_repr_html_`\n",
        "3.  `__mul__`\n",
        "4.  `reset`\n",
        "\n",
        "인스턴스가 아래와 같은 동작을 하도록 설계하라.\n",
        "\n",
        "**시점0: 생성예시 (`__init__`)**"
      ],
      "id": "88452cd7-4315-47c3-87a7-85d4b874b6c9"
    },
    {
      "cell_type": "code",
      "execution_count": 765,
      "metadata": {},
      "outputs": [],
      "source": [
        "a=MookjjibbaPlayer(['묵','찌','빠'])\n",
        "b=MookjjibbaPlayer(['묵','찌','빠'])"
      ],
      "id": "8984389b-00c8-492f-8bc5-cd1f2af91cdf"
    },
    {
      "cell_type": "code",
      "execution_count": 766,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.actions"
      ],
      "id": "e13ad5c3-4193-40da-9e42-96222ced7ee0"
    },
    {
      "cell_type": "code",
      "execution_count": 767,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.modes"
      ],
      "id": "fa83fcca-8076-4559-92fd-365e4d459c19"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> **`__init__` 의 동작**\n",
        ">\n",
        "> 1.  슈퍼클래스(RPS_BASE)의 `__init__`을 동작시킴\n",
        "> 2.  MookjjibbaPlayer의 인스턴가 가지는 actions, modes 값을 \\[None\\]\n",
        ">     으로 초기화\n",
        "\n",
        "**시점0: 출력예시(`_repr_html_`)**"
      ],
      "id": "b0983fd7-fde7-4c2f-8bdf-880c6f902c7b"
    },
    {
      "cell_type": "code",
      "execution_count": 770,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "0c1fb8c9-075d-4809-adce-7b6f3e853023"
    },
    {
      "cell_type": "code",
      "execution_count": 771,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "686ccd5a-4e52-4f66-8e66-48b9b3e1d646"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> **`_repr_html_` 의 동작**\n",
        ">\n",
        "> 위와 같이 “낼 수 있는 패”, “기록”, “모드” 가 함께 출력되도록 설계할 것\n",
        "\n",
        "**시점1: 대결 및 결과출력 (`__mul__`, `_repr_html_`)**"
      ],
      "id": "246a0f6b-4335-48ba-a578-bd744d328df4"
    },
    {
      "cell_type": "code",
      "execution_count": 772,
      "metadata": {},
      "outputs": [],
      "source": [
        "a*b"
      ],
      "id": "0cb07dd4-8247-40d5-aa0f-5a654ef3ffa0"
    },
    {
      "cell_type": "code",
      "execution_count": 773,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "bbce9c1e-5550-491e-8fe7-9d09cc0e44c6"
    },
    {
      "cell_type": "code",
      "execution_count": 774,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "42d07d26-a154-4df5-a176-b8084e3f40f8"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> **`__mul__` 의 동작**\n",
        ">\n",
        "> 1.  두 플레이어의 대결을 진행\n",
        "> 2.  결과를 보고 modes 의 값을 update\n",
        ">\n",
        "> 위의 상황은 두 플레이어 모두 “묵”을 내어 어느쪽도 공격권을 가지지 못한\n",
        "> 상태를 의미\n",
        "\n",
        "**시점2: 대결 및 결과출력 (`__mul__`, `_repr_html_`)**"
      ],
      "id": "58c8f709-d5c5-4319-86d4-b71dbd83478b"
    },
    {
      "cell_type": "code",
      "execution_count": 775,
      "metadata": {},
      "outputs": [],
      "source": [
        "a*b"
      ],
      "id": "2435db8a-0efb-440a-8bdc-8c32ff209eb5"
    },
    {
      "cell_type": "code",
      "execution_count": 776,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "c2e33f6d-2edf-46f1-8cce-105a5c7c0e4b"
    },
    {
      "cell_type": "code",
      "execution_count": 777,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "177b8374-6bda-4bc3-a3f4-a17698cdc597"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> **`__mul__` 의 동작**\n",
        ">\n",
        "> 1.  두 플레이어의 대결을 진행\n",
        "> 2.  결과를 보고 modes 의 값을 update\n",
        ">\n",
        "> 위의 상황은 a가 묵, b가 빠를 내어 b가 공격권을 획득한 상황을 의미\n",
        "\n",
        "**시점3: 대결결과의 초기화 (`reset`)**"
      ],
      "id": "ac47dc27-b9b6-49a4-9bc4-870d3b7ac5c1"
    },
    {
      "cell_type": "code",
      "execution_count": 778,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "c2d05499-b3e0-4fcb-8eea-c2bca07ea62b"
    },
    {
      "cell_type": "code",
      "execution_count": 779,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.reset()"
      ],
      "id": "b5189cd5-443b-4ce0-a932-5162b25a9c43"
    },
    {
      "cell_type": "code",
      "execution_count": 780,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "751baed7-6444-41d2-aeea-17ded64758e1"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> **`reset` 의 동작**\n",
        ">\n",
        "> 1.  플레이어의 기록을 초기화\n",
        "> 2.  플레이어의 모드를 초기화\n",
        "\n",
        "`(4)` `(3)` 에서 생성된 MookjjibbaPlayer의 두 개의 인스턴스 a,b를\n",
        "입력으로 받고 최초공격권을 결정하는 함수 `jumpball`을 설계하라.\n",
        "\n",
        "아래는 jumpball함수의 사용예시이다."
      ],
      "id": "bda952d6-b824-49f1-9d0c-c22867f604b2"
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "49527017-c897-492c-8065-92acc37c222d"
    },
    {
      "cell_type": "code",
      "execution_count": 875,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "670e06d5-c03f-4ea2-a9f2-77df420346c6"
    },
    {
      "cell_type": "code",
      "execution_count": 876,
      "metadata": {},
      "outputs": [],
      "source": [
        "jumpball(a,b)"
      ],
      "id": "78af2550-0da2-4ad7-a052-134c5dcc9b04"
    },
    {
      "cell_type": "code",
      "execution_count": 877,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "e0217bbe-72f6-4805-96cd-cf6bbeabf46a"
    },
    {
      "cell_type": "code",
      "execution_count": 878,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "05e63fee-8ac2-4ff0-b80b-85373803cf52"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "**hint: 아래의 코드를 관찰**"
      ],
      "id": "7d541ba7-7371-4003-9753-c03029fa957f"
    },
    {
      "cell_type": "code",
      "execution_count": 2,
      "metadata": {},
      "outputs": [],
      "source": [
        "a = [] \n",
        "b = [] \n",
        "a.append(np.random.choice([0,1,2]))\n",
        "b.append(np.random.choice([0,1,2]))\n",
        "while a==b: \n",
        "    a.append(np.random.choice([0,1,2]))\n",
        "    b.append(np.random.choice([0,1,2]))"
      ],
      "id": "6aa9219f-8309-49f9-bf1a-acfd8b792c44"
    },
    {
      "cell_type": "code",
      "execution_count": 1079,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "7bf4bd60-5212-4e46-b2e3-2977f39190c4"
    },
    {
      "cell_type": "code",
      "execution_count": 1080,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "4f97d2c7-80e2-4a70-b96b-35fc9b225914"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`(5)` 지금까지 코드를 바탕으로\n",
        "\n",
        "-   a: \\[‘묵’,‘찌’\\] 중 하나를 랜덤으로 고르는 플레이어\n",
        "-   b: \\[‘찌’,‘빠’\\] 중 하나를 랜덤으로 고르는 플레이어\n",
        "\n",
        "를 설정하여 100회 가상대결을 진행하라. 100회 가상대결결과를 제시하라.\n",
        "\n",
        "(참고) – 아래는 제가 구현한 예시입니다. 참고용일 뿐이며 이와 같은\n",
        "방식으로 구현할 필요는 없습니다.\n",
        "\n",
        "**1. a,b 두명의 플레이어 생성**"
      ],
      "id": "124d2fc0-a5a5-47d3-8434-2e72ba89a737"
    },
    {
      "cell_type": "code",
      "execution_count": 1051,
      "metadata": {},
      "outputs": [],
      "source": [
        "a=MookjjibbaPlayer(['묵','찌'])\n",
        "b=MookjjibbaPlayer(['찌','빠'])"
      ],
      "id": "d2e3ce17-77e5-4402-8f59-db68b9d9a0d6"
    },
    {
      "cell_type": "code",
      "execution_count": 1052,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "954789d6-5e6e-42a7-93bb-35e8a72c0914"
    },
    {
      "cell_type": "code",
      "execution_count": 1053,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "6014c33c-3058-41ae-8ba5-939783ca1677"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> a,b 플레이어가 초기화\n",
        "\n",
        "**2. a,b 두명의 플레이어를 입력으로 하여 게임1을 생성후 1회 게임진행**"
      ],
      "id": "c6b9eed1-7176-408c-afd1-a7140139134d"
    },
    {
      "cell_type": "code",
      "execution_count": 1054,
      "metadata": {},
      "outputs": [],
      "source": [
        "game = PlayMookjjibba(a,b)"
      ],
      "id": "9ee012f7-062e-46d6-b8f9-cbcd390885b2"
    },
    {
      "cell_type": "code",
      "execution_count": 1055,
      "metadata": {},
      "outputs": [],
      "source": [
        "game.play()"
      ],
      "id": "56aae94f-6e9f-4021-b0f2-4c667fa9cfe8"
    },
    {
      "cell_type": "code",
      "execution_count": 1056,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "a533429f-928e-4f70-8675-43f025436ec7"
    },
    {
      "cell_type": "code",
      "execution_count": 1057,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "4b5e9448-7397-4561-b385-208d6b62dbc6"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> a가 찌, b가 빠를 내어 최초 공격권을 a가 획득하였지만 이후 공격권을\n",
        "> 상실한 상실함. 이후 4번째 가위바위보에서 b가 a가 동시에 찌를 내며 b의\n",
        "> 승리로 마무리됨\n",
        "\n",
        "**3. game.records 에 b의 승리가 기록되어 있음**"
      ],
      "id": "7b573378-762f-47d2-9d15-61486df982e5"
    },
    {
      "cell_type": "code",
      "execution_count": 1058,
      "metadata": {},
      "outputs": [],
      "source": [
        "game.records "
      ],
      "id": "1efcadb0-b63d-4600-a1e7-25bcbaf1f6ba"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "**4. 1회 대결기록을 삭제하고 또 다른 게임을 진행: 이번에는 a의 승리**"
      ],
      "id": "161cadc1-2033-4b33-bfc8-de3351a7a7f7"
    },
    {
      "cell_type": "code",
      "execution_count": 1059,
      "metadata": {},
      "outputs": [],
      "source": [
        "game.reset_player_history()"
      ],
      "id": "61f29fac-80af-490a-b707-dc91390e531b"
    },
    {
      "cell_type": "code",
      "execution_count": 1060,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "f459dade-2c1f-4463-bc5a-f875bc16eb32"
    },
    {
      "cell_type": "code",
      "execution_count": 1061,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "47e5f29d-33f0-43c4-9eda-79e03cf64016"
    },
    {
      "cell_type": "code",
      "execution_count": 1062,
      "metadata": {},
      "outputs": [],
      "source": [
        "game.play()"
      ],
      "id": "18b8ef2c-4fc2-4983-8b82-1c602125d129"
    },
    {
      "cell_type": "code",
      "execution_count": 1063,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "1e4e79e1-8891-43bc-b292-e0f24d19710b"
    },
    {
      "cell_type": "code",
      "execution_count": 1064,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "971ae2e2-7167-43e9-840a-eb4b7ed0b168"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> 공격권은 2번만에 A가 획득, 1번의 공격을 통하여 마무리\n",
        "\n",
        "**5. 이번에는 a의 승리가 기록됨**"
      ],
      "id": "7fdda2e7-d98b-445f-9158-d7f0f284cb26"
    },
    {
      "cell_type": "code",
      "execution_count": 1065,
      "metadata": {},
      "outputs": [],
      "source": [
        "game.records"
      ],
      "id": "eedbd398-4d5b-4aba-9a27-ec7a0c0bb25c"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "# `2`. 종합문항 (50점)\n",
        "\n",
        "`(1)` LinearRegression 이라는 이름의 클래스를 만들고 아래의 기능을\n",
        "넣어라.\n",
        "\n",
        "**`__init__`**: “클래스 $\\to$ 인스턴스” 인 시점에 길이가 $n$인 numpy\n",
        "array ${\\bf x}=(x_1,\\dots,x_n)$, ${\\bf y}=(y_1,\\dots,y_n)$을 입력으로\n",
        "받아 내부에 저장한다.\n",
        "\n",
        "**`fit`**: fit은 내부에 저장된 ${\\bf x}$, ${\\bf y}$를 이용하여\n",
        "$\\hat{\\bf y}=(\\hat{y}_1,\\dots,\\hat{y}_n)$을 계산하는 역할을 한다. 계산은\n",
        "아래의 수식을 이용한다.\n",
        "$$\\hat{\\bf y}= {\\bf X}({\\bf X}^T {\\bf X})^{-1}{\\bf X}^T {\\bf y}, \\quad {\\bf X}=\\begin{bmatrix} 1 & x_1 \\\\ 1 & x_2 \\\\ \\dots \\\\ 1 & x_n \\end{bmatrix}$$\n",
        "\n",
        "**`plot`**: plot은 $(x_i,y_i)$와 $(x_i,\\hat{y}_i)$를 시각화하는 역할을\n",
        "한다.\n",
        "\n",
        "아래의 자료를 LinearRegression의 입력으로 받고 시각화하는 분석을\n",
        "수행하라."
      ],
      "id": "29b71873-0800-4a5e-8858-49d51c906276"
    },
    {
      "cell_type": "code",
      "execution_count": 1098,
      "metadata": {},
      "outputs": [
        {
          "output_type": "display_data",
          "metadata": {},
          "data": {
            "image/png": "iVBORw0KGgoAAAANSUhEUgAAAXIAAAD4CAYAAADxeG0DAAAAOXRFWHRTb2Z0d2FyZQBNYXRwbG90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\nRyAHgMz9P6DE9grSRLaQAAAAAElFTkSuQmCC\n"
          }
        }
      ],
      "source": [
        "x = np.linspace(0,1,100)\n",
        "y = 2*x + np.random.normal(size=100)\n",
        "plt.plot(x,y,'o')"
      ],
      "id": "7c268703-3d76-4583-94b1-b1c6196b13d7"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`(2)` 앞면과 뒷면이 나올 확률이 각각 1/2인 동전을 생각하자. 하니와\n",
        "규빈은 이 동전을 연속으로 던져서 아래와 같은 룰을 정하여 내기를 하였다.\n",
        "\n",
        "-   동전을 연속으로 반복하여 던진다. 최근 2회의 결과가 (뒷면,앞면) 이\n",
        "    나오면 하니의 승리\n",
        "-   동전을 연속으로 반복하여 던진다. 최근 2회의 결과가 (뒷면,뒷면) 이\n",
        "    나오면 규빈의 승리\n",
        "\n",
        "이 내기는 하니가 유리한가? 규빈이 유리한가? 시뮬레이션을 통해 검증하라.\n",
        "\n",
        "> **Note**\n",
        ">\n",
        "> **hint**: 똑같이 유리하다\n",
        "\n",
        "`(3)` 앞면과 뒷면이 나올 확률이 각각 1/2인 동전을 생각하자. 하니와\n",
        "규빈은 이 동전을 연속으로 던져서 아래와 같은 룰을 정하여 내기를 하였다.\n",
        "\n",
        "-   동전을 연속으로 반복하여 던진다. 최근 2회의 결과가 (앞면,뒷면) 이\n",
        "    나오면 하니의 승리\n",
        "-   동전을 연속으로 반복하여 던진다. 최근 2회의 결과가 (뒷면,뒷면) 이\n",
        "    나오면 규빈의 승리\n",
        "\n",
        "이 내기는 하니가 유리한가? 규빈이 유리한가? 시뮬레이션을 통해 검증하라.\n",
        "\n",
        "> **Note**\n",
        ">\n",
        "> **hint**: 이 내기는 하니가 유리하다.\n",
        "\n",
        "`(4)` Time을 상속받아 Init 클래스를 만들고 `__repr__`을 조작하여 아래와\n",
        "같이 인스턴스 생성시점을 출력하는 기능을 구현하라."
      ],
      "id": "d5f7cda1-cca8-4f3f-bc8e-432b83d93831"
    },
    {
      "cell_type": "code",
      "execution_count": 599,
      "metadata": {},
      "outputs": [],
      "source": [
        "class Time:\n",
        "    def time(self):\n",
        "        return datetime.datetime.now().strftime('%y-%m-%d %X')"
      ],
      "id": "bdf5381e-7a91-4c8d-a74a-42684628be2f"
    },
    {
      "cell_type": "code",
      "execution_count": 641,
      "metadata": {},
      "outputs": [],
      "source": [
        "a = Init()"
      ],
      "id": "03cc19b6-4197-4f45-9dd6-421b6c4e49a2"
    },
    {
      "cell_type": "code",
      "execution_count": 642,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "37468a08-14e9-4613-9c26-e53c7cd1567d"
    },
    {
      "cell_type": "code",
      "execution_count": 643,
      "metadata": {},
      "outputs": [],
      "source": [
        "b = Init()"
      ],
      "id": "a3f4d1cc-d3e6-49e9-8e88-a9813d3d879e"
    },
    {
      "cell_type": "code",
      "execution_count": 644,
      "metadata": {},
      "outputs": [],
      "source": [
        "a,b"
      ],
      "id": "64f0e7aa-381e-45f5-9038-17877ab5e31e"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`(5)` tuple 클래스와 아래의 Check를 상속받아 아래와 같은 역할을 하는\n",
        "새로운 Tuple 클래스를 만들라."
      ],
      "id": "420db0e9-3732-4d64-9251-ef8168af2f4d"
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {},
      "outputs": [],
      "source": [
        "class Check:\n",
        "    def ckeck(self):\n",
        "        return [l for l in dir(self) if l[0]!='_']"
      ],
      "id": "acfd1c37-e900-4544-9099-158d0d806321"
    },
    {
      "cell_type": "code",
      "execution_count": 677,
      "metadata": {},
      "outputs": [],
      "source": [
        "tpl = Tuple('asdfassdfsasdf')\n",
        "tpl # 값과 함께 사용가능한 메소드가 함께 출력 "
      ],
      "id": "fdae6374-c612-491b-9eb8-780c160d0292"
    },
    {
      "cell_type": "code",
      "execution_count": 676,
      "metadata": {},
      "outputs": [],
      "source": [
        "tpl.freq()"
      ],
      "id": "9f2f73c2-0f3c-447c-a4c2-0c04d5f37949"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`(6)` 아래와 같은 클래스를 고려하자."
      ],
      "id": "e48e26fb-c258-439a-a013-762f7f24bfdf"
    },
    {
      "cell_type": "code",
      "execution_count": 1103,
      "metadata": {},
      "outputs": [],
      "source": [
        "class Init(object):\n",
        "    def __init__(self,value):\n",
        "        self.value = value\n",
        "        \n",
        "class Times2(Init):\n",
        "    def __init__(self,value):\n",
        "        super().__init__(value)\n",
        "        self.value = self.value * 2\n",
        "        \n",
        "class Plus5(Init):\n",
        "    def __init__(self,value):\n",
        "        super().__init__(value)\n",
        "        self.value = self.value + 5"
      ],
      "id": "2ed230a8-1c61-43fd-8ebc-4485e17e6c51"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`Plus5`와 `Times2`를 상속하여 적당한 클래스 `Times2Plus5`를 정의하고\n",
        "생성과 동시에 $x \\to (x\\times 2)+5$ 를 수행도록 하라.\n",
        "\n",
        "**사용예시**"
      ],
      "id": "8c6a7825-2fda-47af-9161-c25dfc951a6b"
    },
    {
      "cell_type": "code",
      "execution_count": 1105,
      "metadata": {},
      "outputs": [],
      "source": [
        "a=Times2Plus5(0)\n",
        "a.value"
      ],
      "id": "a3cf737e-8864-4628-9dec-3afac5d154b8"
    },
    {
      "cell_type": "code",
      "execution_count": 1106,
      "metadata": {},
      "outputs": [],
      "source": [
        "a=Times2Plus5(1)\n",
        "a.value"
      ],
      "id": "5de1aebe-d00e-41c6-8e25-839b0beb2622"
    },
    {
      "cell_type": "code",
      "execution_count": 1107,
      "metadata": {},
      "outputs": [],
      "source": [
        "a=Times2Plus5(5)\n",
        "a.value"
      ],
      "id": "b916f7ae-83f6-49fc-a265-9c9dd74f1702"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`(7)` 아래의 함수가 있다고 하자."
      ],
      "id": "79aa95ae-5777-4c82-96c6-f0dbcb651e0a"
    },
    {
      "cell_type": "code",
      "execution_count": 1108,
      "metadata": {},
      "outputs": [],
      "source": [
        "def f(x): \n",
        "    return np.sin(x)"
      ],
      "id": "3fbe5122-be5f-4ef4-b531-c4b3608a47e4"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "적당한 함수 `derivate`를 정의하여 함수를 입력으로 받으면 그 도함수를\n",
        "출력으로 리턴하도록 하라. 아래의 코드를 이용하여 검증하라."
      ],
      "id": "2cc20655-4e7b-4926-aa38-52ae481c0d55"
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {},
      "outputs": [
        {
          "output_type": "display_data",
          "metadata": {},
          "data": {
            "image/png": "iVBORw0KGgoAAAANSUhEUgAAAYIAAAD4CAYAAADhNOGaAAAAOXRFWHRTb2Z0d2FyZQBNYXRwbG90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\nJiYmJiMc0xCYmJiYjHBMQ2BiYmIywvn/PMb/0NUihFsAAAAASUVORK5CYII=\n"
          }
        }
      ],
      "source": [
        "x = np.linspace(-6,6,100)\n",
        "plt.plot(x,f(x),label=r'$f(x)=\\sin(x)$')\n",
        "plt.plot(x,(derivate(f))(x),label=r'$f\\'(x)=\\cos(x)$')\n",
        "plt.legend()"
      ],
      "id": "b5e24b2c-bdea-43fd-a22c-28cd08878551"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`(8)` Student 클래스를 생성지침 및 사용예시를 참고하여 설계하라.\n",
        "\n",
        "**`생성지침`**\n",
        "\n",
        "**attributes**\n",
        "\n",
        "-   `name`: 이름을 저장하는 변수\n",
        "-   `age`: 나이를 저장하는 변수\n",
        "-   `semester`: 학기를 저장하는 변수\n",
        "\n",
        "**methods**\n",
        "\n",
        "-   `__init__`: name, age, semester 세 가지 매개변수를 입력받아\n",
        "    인스턴스의 attribute로 저장\n",
        "-   `__str__`: 인스턴스의 정보(이름,나이,학기)를 문자열 형태로 반환\n",
        "\n",
        "**`사용예시`**"
      ],
      "id": "d0eacc92-979d-4d7c-a5e1-193ffade3a12"
    },
    {
      "cell_type": "code",
      "execution_count": 224,
      "metadata": {},
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "이름: 김보람\n",
            "나이: 20\n",
            "학기: 1"
          ]
        }
      ],
      "source": [
        "# 사용 예시\n",
        "boram = Student(name='김보람', age=20, semester=1)\n",
        "print(boram)"
      ],
      "id": "ac042625-284c-443f-b04c-ae8048359d59"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`(9)` 8의 클래스를 상속받아 Student2 만들라. `__add__` 재정의하여\n",
        "Student2의 인스턴스가 아래와 같이 동작하도록 하라."
      ],
      "id": "1b2ac809-15d0-4eba-a94b-5a677c382e28"
    },
    {
      "cell_type": "code",
      "execution_count": 1122,
      "metadata": {},
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "입학을 축하합니다. 당신의 나이는 20.0이고 현재 학기는 0학기 입니다."
          ]
        }
      ],
      "source": [
        "boram = Student2()"
      ],
      "id": "79ba8e3f-eda9-455d-b24f-4f73c97776d8"
    },
    {
      "cell_type": "code",
      "execution_count": 1123,
      "metadata": {},
      "outputs": [],
      "source": [
        "boram + '등록'+ '휴학' + '등록' + '휴학'\n",
        "boram"
      ],
      "id": "330f9b64-6d6b-47f7-b2b6-d2b51f4c1cc5"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> 4학기가 지났으므로 나이는 22살이 된다. 4학기중 2학기만 등록하였으므로\n",
        "> 현재는 2학기를 마친상태이다.\n",
        "\n",
        "`(10)` 적당한 클래스를 선언하여 $f(x)=x+{\\tt const}$를 수행하는 함수를\n",
        "생성하도록 하라.\n",
        "\n",
        "**사용예시1**"
      ],
      "id": "02cb8c3f-3158-4599-996f-6c6ad3971e0b"
    },
    {
      "cell_type": "code",
      "execution_count": 1125,
      "metadata": {},
      "outputs": [],
      "source": [
        "f = AddConstant(5) # f(x) = x+5 "
      ],
      "id": "0bada165-89ff-4735-ad32-7064ca4fab7a"
    },
    {
      "cell_type": "code",
      "execution_count": 1126,
      "metadata": {},
      "outputs": [],
      "source": [
        "f(10)"
      ],
      "id": "50bd0e97-f4e7-419e-9cd4-97bde3a78f6d"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "**사용예시2**"
      ],
      "id": "b67fb89d-d0d2-4b53-b30f-c59690ed55e4"
    },
    {
      "cell_type": "code",
      "execution_count": 1127,
      "metadata": {},
      "outputs": [],
      "source": [
        "f = AddConstant(-3) # f(x) = x-3"
      ],
      "id": "a2fab431-486d-413b-807c-eb0b216fe24b"
    },
    {
      "cell_type": "code",
      "execution_count": 1128,
      "metadata": {},
      "outputs": [],
      "source": [
        "f(10)"
      ],
      "id": "e51199e0-f454-415e-b917-2f64e34c7d90"
    }
  ],
  "nbformat": 4,
  "nbformat_minor": 5,
  "metadata": {
    "kernelspec": {
      "name": "python3",
      "display_name": "Python 3",
      "language": "python"
    },
    "language_info": {
      "name": "python",
      "codemirror_mode": {
        "name": "ipython",
        "version": "3"
      },
      "file_extension": ".py",
      "mimetype": "text/x-python",
      "nbconvert_exporter": "python",
      "pygments_lexer": "ipython3",
      "version": "3.8.16"
    }
  }
}